﻿Imports System.Runtime.InteropServices

Public Class CAN_Sample
    ' IMPORTS
    Private Declare Function CAN_Open Lib "CANDLL_STDCALL.dll" (ByVal ComPort As String,
                                                                ByVal szBitrate As String,
                                                                ByVal acceptance_code As String,
                                                                ByVal acceptance_mask As String,
                                                                ByVal flags As IntPtr,
                                                                ByVal Mode As Integer) As Integer
    Private Declare Function CAN_Close Lib "CANDLL_STDCALL.dll" (ByVal Handle As Integer) As Integer
    Private Declare Function CAN_Write Lib "CANDLL_STDCALL.dll" (ByVal Handle As Integer, ByRef CANMSG As CAN_MSG) As Integer
    Private Declare Function CAN_Read Lib "CANDLL_STDCALL.dll" (ByVal Handle As Integer, ByRef CANMSG As CAN_MSG) As Integer

    ' CAN_MSG Structure
    Public Structure CAN_MSG
        <MarshalAs(UnmanagedType.U4)>
        Public Id As UInteger
        <MarshalAs(UnmanagedType.U1)>
        Public Size As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=8, ArraySubType:=UnmanagedType.U1)>
        Public Data As Byte()
        <MarshalAs(UnmanagedType.U1)>
        Public Flags As Byte
        <MarshalAs(UnmanagedType.U2)>
        Public Timestamp As UShort
    End Structure

    ' Declaration
    Public Shared myHandle As Integer = 0
    Public Shared myWriteCANMSG As CAN_MSG
    Public Shared myReadCANMSG As CAN_MSG
    Private Const welcomeMsg As String = "Welcome to TITAN CAN VB.NET Sample Program. We hope that this sample code will allow " _
        & "you to further understand the way to use our TITAN CAN DLL to create your own programs."

    ' Constructor
    Public Sub New()
        InitializeComponent()
        ReDim myWriteCANMSG.Data(7)
        ReDim myReadCANMSG.Data(7)
        MsgBox(welcomeMsg, MsgBoxStyle.ApplicationModal, "TITAN CAN VB.NET Sample")
    End Sub

    Private Sub open_button_Click(sender As Object, e As EventArgs) Handles open_button.Click
        ' Prompts user for COM port to open with text box
        myHandle = CAN_Open(comport_fld.Text, "1000", "00000000", "00000000", "1", "2")
        If (myHandle > 0) Then
            MsgBox("CAN Open successful!")
        ElseIf (myHandle = -2) Then
            MsgBox("Error opening channel! Check if the COM port number is correct.")
            myHandle = 0
        ElseIf (myHandle = -1) Then
            MsgBox("Error communicating with device!")
            myHandle = 0
        End If
    End Sub

    Private Sub close_button_Click(sender As Object, e As EventArgs) Handles close_button.Click
        Dim ret As Integer
        ' Test CAN_Close
        ret = CAN_Close(myHandle)
        If (ret = 1) Then
            MsgBox("CAN_Close successful!")
        ElseIf (ret = -4) Then
            MsgBox("COM port is not open!")
        ElseIf (ret = -1) Then
            MsgBox("Error communicating with device!")
        End If
    End Sub

    Private Sub write_button_Click(sender As Object, e As EventArgs) Handles write_button.Click
        Dim ret As Integer
        ' Create message to write
        myWriteCANMSG.Id = &H1FFFFFFF
        myWriteCANMSG.Size = 8
        Dim i As Integer
        For i = 0 To 7
            myWriteCANMSG.Data(i) = i
        Next
        myWriteCANMSG.Flags = 10
        ' Test CAN_Write
        ret = CAN_Write(myHandle, myWriteCANMSG)
        If (ret = 1) Then
            MsgBox("CAN_Write successful!")
        ElseIf (ret = -4) Then
            MsgBox("COM port is not open!")
        ElseIf (ret = -1) Then
            MsgBox("Error communicating with device!")
        End If
    End Sub

    Private Sub read_button_Click(sender As Object, e As EventArgs) Handles read_button.Click
        Dim ret As Integer
        ' Test CAN_Read
        ret = CAN_Read(myHandle, myReadCANMSG)
        If (ret = 1) Then
            MsgBox("CAN_Read successful!" & vbCrLf & "ID: " & Hex(myReadCANMSG.Id) _
            & vbCrLf & "Size: " & myReadCANMSG.Size & vbCrLf & "Data: " _
            & myReadCANMSG.Data(0) & " " & myReadCANMSG.Data(1) & " " _
            & myReadCANMSG.Data(2) & " " & myReadCANMSG.Data(3) & " " _
            & myReadCANMSG.Data(4) & " " & myReadCANMSG.Data(5) & " " _
            & myReadCANMSG.Data(6) & " " & myReadCANMSG.Data(7) & " " _
            & vbCrLf & "Flags: " & myReadCANMSG.Flags & vbCrLf & "Timestamp: " _
            & Hex(myReadCANMSG.Timestamp))
        ElseIf (ret = -5) Then
            MsgBox("Message is empty!")
        ElseIf (ret = -4) Then
            MsgBox("COM port is not open!")
        ElseIf (ret = -1) Then
            MsgBox("Error communicating with device!")
        End If
    End Sub
End Class
