VERSION 5.00
Begin VB.Form mainForm 
   Caption         =   "TITAN CAN VB6 Sample"
   ClientHeight    =   3360
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   3990
   Icon            =   "TITAN CAN VB6 Sample.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   224
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   266
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox comport_fld 
      Height          =   285
      Left            =   720
      TabIndex        =   5
      Text            =   "COM3"
      Top             =   1680
      Width           =   1095
   End
   Begin VB.CommandButton read_button 
      Caption         =   "Read"
      Height          =   495
      Left            =   2160
      TabIndex        =   3
      Top             =   1800
      Width           =   1215
   End
   Begin VB.CommandButton write_button 
      Caption         =   "Write"
      Height          =   495
      Left            =   2160
      TabIndex        =   2
      Top             =   1080
      Width           =   1215
   End
   Begin VB.CommandButton close_button 
      Caption         =   "Close"
      Height          =   495
      Left            =   2160
      TabIndex        =   1
      Top             =   2520
      Width           =   1215
   End
   Begin VB.CommandButton open_button 
      Caption         =   "Open"
      Height          =   495
      Left            =   2160
      TabIndex        =   0
      Top             =   360
      Width           =   1215
   End
   Begin VB.Label comport_lbl 
      Caption         =   "COM Port"
      Height          =   255
      Left            =   720
      TabIndex        =   4
      Top             =   1320
      Width           =   1095
   End
End
Attribute VB_Name = "mainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' File name: CAN_Sample.frm: Sample code for using CAN API
' Author: Frank Ying
' Copyright: Copyright 2017, Titan Electronics Inc.
' Version: 1.0.0
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

' IMPORTS
Private Declare Function CAN_Open _
Lib "CANDLL_STDCALL.dll" _
(ByVal ComPort As String, ByVal szBitrate As String, ByVal acceptance_code As String, _
ByVal acceptance_mask As String, ByVal Flags As Long, ByVal Mode As Long) As Long

Private Declare Function CAN_Close _
Lib "CANDLL_STDCALL.dll" _
(ByVal Handle As Long) As Long

Private Declare Function CAN_Write _
Lib "CANDLL_STDCALL.dll" _
(ByVal Handle As Long, ByRef CANMSG As CAN_MSG) As Long

Private Declare Function CAN_Read _
Lib "CANDLL_STDCALL.dll" _
(ByVal Handle As Long, ByRef CANMSG As CAN_MSG) As Long

' CAN_MSG Structure
Private Type CAN_MSG
    Id As Long
    Size As Byte
    Data(0 To 7) As Byte
    Flags As Byte
    Timestamp As Integer
End Type

' Declaration
Private myHandle As Integer
Private myWriteCANMSG As CAN_MSG
Private myReadCANMSG As CAN_MSG
Private Const welcomeMsg As String = "Welcome to the sample code of TITAN CAN " _
& "VB6 API. We hope that this sample code will allow you to further understand " _
& "the way to use our TITAN CAN DLL to create your own programs."

' Constructor
Private Sub Form_Load()
    ' Show welcome message
    MsgBox welcomeMsg, vbOKOnly, "Welcome to TITAN CAN API Sample Program!"
End Sub

' Action when open button is clicked
Private Sub open_button_Click()
    ' Prompts user for COM port to open with text box
    myHandle = CAN_Open(comport_fld.Text, "1000", "00000000", "00000000", "1", "2")
    If (myHandle > 0) Then
        MsgBox "CAN Open successful!"
    ElseIf (myHandle = -2) Then
        MsgBox "Error opening channel! Check if the COM port number is correct."
        myHandle = 0
    ElseIf (myHandle = -1) Then
        MsgBox "Error communicating with device!"
        myHandle = 0
    End If
End Sub

' Action when close button is clicked
Private Sub close_button_Click()
    Dim ret As Integer
    ' Test CAN_Close
    ret = CAN_Close(myHandle)
    If (ret = 1) Then
        MsgBox "CAN_Close successful!"
    ElseIf (ret = -4) Then
        MsgBox "COM port is not open!"
    ElseIf (ret = -1) Then
        MsgBox "Error communicating with device!"
    End If
End Sub

' Action when write button is clicked
Private Sub write_button_Click()
    Dim ret As Integer
    ' Create message to write
    myWriteCANMSG.Id = &H1FFFFFFF
    myWriteCANMSG.Size = 8
    Dim i As Integer
    For i = 0 To 7
        myWriteCANMSG.Data(i) = i
    Next
    myWriteCANMSG.Flags = 10
    ' Test CAN_Write
    ret = CAN_Write(myHandle, myWriteCANMSG)
    If (ret = 1) Then
        MsgBox "CAN_Write successful!"
    ElseIf (ret = -4) Then
        MsgBox "COM port is not open!"
    ElseIf (ret = -1) Then
        MsgBox "Error communicating with device!"
    End If
End Sub

' Action when read button is clicked
Private Sub read_button_Click()
    Dim ret As Integer
    ' Test CAN_Read
    ret = CAN_Read(myHandle, myReadCANMSG)
    If (ret = 1) Then
        MsgBox "CAN_Read successful!" & vbCrLf & "ID: " & Hex(myReadCANMSG.Id) _
        & vbCrLf & "Size: " & myReadCANMSG.Size & vbCrLf & "Data: " _
        & myReadCANMSG.Data(0) & " " & myReadCANMSG.Data(1) & " " _
        & myReadCANMSG.Data(2) & " " & myReadCANMSG.Data(3) & " " _
        & myReadCANMSG.Data(4) & " " & myReadCANMSG.Data(5) & " " _
        & myReadCANMSG.Data(6) & " " & myReadCANMSG.Data(7) & " " _
        & vbCrLf & "Flags: " & myReadCANMSG.Flags & vbCrLf & "Timestamp: " _
        & Hex(myReadCANMSG.Timestamp)
    ElseIf (ret = -5) Then
        MsgBox "Message is empty!"
    ElseIf (ret = -4) Then
        MsgBox "COM port is not open!"
    ElseIf (ret = -1) Then
        MsgBox "Error communicating with device!"
    End If
End Sub
